//  yv122nv12.cpp
//
//	YV12 to NV12 converter
//
//	Copyright (c) 2004
//

#define WIN32_LEAN_AND_MEAN		// Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>

#include <streams.h>
#include <dvdmedia.h>
#include <aviriff.h> 
#include <initguid.h>
#include <mmintrin.h>
#include "yv122nv12.h"

//摜̉̃ACg
#define WIDTH_ALIGN 128

extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}

///custom allocater
HRESULT Cyv122nv12Allocator::ChangeMediaType(AM_MEDIA_TYPE *pMediaType)
{
	CheckPointer(pMediaType,E_POINTER);

	if(pMT){
		DeleteMediaType(pMT);
	}
	pMT = CreateMediaType(pMediaType);
	if(pMT) ch = TRUE;

	return NOERROR;
}

HRESULT Cyv122nv12Allocator::SetMediaType(AM_MEDIA_TYPE *pMediaType)
{
	CheckPointer(pMediaType,E_POINTER);

	if(pMT){
		DeleteMediaType(pMT);
	}
	pMT = CreateMediaType(pMediaType);

	return NOERROR;
}

//fBA^CvA^b`
STDMETHODIMP Cyv122nv12Allocator::GetBuffer(IMediaSample **ppBuffer,
											REFERENCE_TIME *pStartTime,
											REFERENCE_TIME *pEndTime,
											DWORD dwFlags)
{
	HRESULT hr;
	hr = CBaseAllocator::GetBuffer(ppBuffer, pStartTime, pEndTime, dwFlags);
	if (FAILED(hr)) {
		return hr;
	}

	if(ch){
		ch = FALSE;
		if(pMT){
			hr = (*ppBuffer)->SetMediaType(pMT);
		}
	}

	return hr;
}

STDMETHODIMP 
Cyv122nv12Allocator::SetProperties(ALLOCATOR_PROPERTIES *pRequest, ALLOCATOR_PROPERTIES *pActual)
{
	long size = 0;

	HRESULT hr = CBaseAllocator::SetProperties(pRequest, pActual);
	if (FAILED(hr)) {
		return hr;
	}
	if(pMT){
		BITMAPINFOHEADER *pbmi;
		if (pMT->formattype == FORMAT_VideoInfo && pMT->cbFormat >= sizeof(VIDEOINFOHEADER)){
			pbmi = &((VIDEOINFOHEADER *)(pMT->pbFormat))->bmiHeader;
		} else if (pMT->formattype == FORMAT_VideoInfo2 && pMT->cbFormat >= sizeof(VIDEOINFOHEADER2)) {
			pbmi = &((VIDEOINFOHEADER2 *)(pMT->pbFormat))->bmiHeader;
		} else {
			//ɂ͗Ȃ
			return E_UNEXPECTED;
		}
		size = (pbmi->biWidth + (WIDTH_ALIGN-1)) & ~(WIDTH_ALIGN-1); //128bitAC
		size = pbmi->biHeight * (size + (size>>1));
		size = abs(size);
	}
	pActual->cbBuffer = m_lSize =
		pRequest->cbBuffer > size ? pRequest->cbBuffer : size;

	return hr;
}

//custom input pin
STDMETHODIMP Cyv122nv12InputPin::GetAllocator(IMemAllocator **ppAllocator)
{
	CheckPointer(ppAllocator,E_POINTER);
	ValidateReadWritePtr(ppAllocator,sizeof(IMemAllocator *));
	CAutoLock cObjectLock(m_pLock);

	if (m_pAllocator) {
		// ɃAP[^邽߁ÃAP[^ԂB
		*ppAllocator = m_pAllocator;
		(*ppAllocator)->AddRef();
		return S_OK;
	}

	// AP[^Ȃ߁AJX^ AP[^񎦂Bł̃R[h̍ו́A
	// JX^ AP[^̃NX`ɂĈقȂB
	HRESULT hr = S_OK;
	Cyv122nv12Allocator *pAlloc = 
		new Cyv122nv12Allocator(NAME("Cyv122nv12Allocator"), NULL, &hr);
	if (!pAlloc) {
		return E_OUTOFMEMORY;
	}
	if (FAILED(hr)) {
		delete pAlloc;
		pAlloc = NULL;
		return hr;
	}
	// Ăяo IMemAllocator C^[tFCXԂB
	hr = pAlloc->QueryInterface(IID_IMemAllocator, (void**)&m_pAllocator);
	if (FAILED(hr)) {
		delete pAlloc;
		pAlloc = NULL;
		return hr;
	}

	m_pAllocator = pAlloc;

	ASSERT(m_pAllocator != NULL);
    *ppAllocator = m_pAllocator;
    m_pAllocator->AddRef();

	AM_MEDIA_TYPE pMediaType;
	if(S_OK == ConnectionMediaType(&pMediaType)){
		static_cast<Cyv122nv12Allocator*>(m_pAllocator)->SetMediaType(&pMediaType);
		FreeMediaType(pMediaType);
	}

    return NOERROR;
}

//AP[^̑I
STDMETHODIMP Cyv122nv12InputPin::NotifyAllocator(IMemAllocator * pAllocator, BOOL bReadOnly)
{
	CheckPointer(pAllocator,E_POINTER);
	ValidateReadPtr(pAllocator,sizeof(IMemAllocator));
	CAutoLock cObjectLock(m_pLock);

	IMemAllocator *pOldAllocator = m_pAllocator;
	if(pAllocator == m_pAllocator) { //using custom_allocater
		CustomAllocater = TRUE;
	} else {
		CustomAllocater = FALSE;
		pAllocator->AddRef();
		m_pAllocator = pAllocator;

		if(pOldAllocator != NULL){
			pOldAllocator->Release();
		}
	}

	// the readonly flag indicates whether samples from this allocator should
	// be regarded as readonly - if true, then inplace transforms will not be
	// allowed.
	m_bReadOnly = (BYTE)bReadOnly;
	return NOERROR;
}

//constructor
Cyv122nv12::Cyv122nv12(TCHAR *tszName, LPUNKNOWN punk)
        : CTransformFilter (tszName, punk, CLSID_YV122NV12)
{ 
	hIn = wIn = swIn = hOut = wOut = swOut = 0;
	mmx = 0;

	//mmxo
	__asm{
			mov eax, 1
			cpuid
			test edx, 00800000h
			jz no
	}
			mmx = 1;
	__asm no:
}

//input pinI[o[Ch
CBasePin * Cyv122nv12::GetPin(int n)
{
	HRESULT hr = S_OK;

	// Create an input pin if necessary
	if (m_pInput == NULL) {

		m_pInput = new Cyv122nv12InputPin(NAME("Transform input pin"), 
			this,              // Owner filter
			&hr,               // Result code
			L"XForm In");      // Pin name

		//  Can't fail
		ASSERT(SUCCEEDED(hr));
		if (m_pInput == NULL) {
			return NULL;
		}
		m_pOutput = (CTransformOutputPin *)
			new CTransformOutputPin(NAME("Transform output pin"),
			this,            // Owner filter
			&hr,             // Result code
			L"XForm Out");   // Pin name


		// Can't fail
		ASSERT(SUCCEEDED(hr));
		if (m_pOutput == NULL) {
			delete m_pInput;
			m_pInput = NULL;
		}
	}

	// Return the appropriate pin

	if (n == 0) {
		return m_pInput;
	} else if (n == 1) {
		return m_pOutput;
	} else {
		return NULL;
	}
}


//͂̃`FbN
HRESULT Cyv122nv12::CheckInputType(const CMediaType *mtIn)
{
    if (mtIn->majortype != MEDIATYPE_Video)
	{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    if (mtIn->subtype != MEDIASUBTYPE_YV12)
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	BITMAPINFOHEADER *pbmi;
	if (mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &(((VIDEOINFOHEADER *)(mtIn->Format()))->bmiHeader);
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmi = &(((VIDEOINFOHEADER2 *)(mtIn->Format()))->bmiHeader);
	}
	else{
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	if (pbmi->biCompression != FCC('YV12')){
		return VFW_E_TYPE_NOT_ACCEPTED;
	}


    // ׂĖȂB
    return S_OK;
}

//o͌`̒
HRESULT Cyv122nv12::GetMediaType(int iPosition, CMediaType *pMediaType)
{
    ASSERT(m_pInput->IsConnected());
    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }
    if (iPosition == 0)
    {
        HRESULT hr = m_pInput->ConnectionMediaType(pMediaType);
        if (FAILED(hr))
        {
            return hr;
        }
        pMediaType->subtype = MEDIASUBTYPE_NV12;

		//BITMAPINFOHEADERł̃^Cvw
        BITMAPINFOHEADER *pbmi;
		if (pMediaType->formattype == FORMAT_VideoInfo && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER))
		{
			pbmi = &((VIDEOINFOHEADER *)(pMediaType->Format()))->bmiHeader;
		}
		else if (pMediaType->formattype == FORMAT_VideoInfo2 && pMediaType->cbFormat >= sizeof(VIDEOINFOHEADER2))
		{
			pbmi = &((VIDEOINFOHEADER2 *)(pMediaType->Format()))->bmiHeader;
		}
		else
		{
			return E_UNEXPECTED;
		}

		pbmi->biCompression = FCC('NV12');

        return S_OK;
    }
    // else
    return VFW_S_NO_MORE_ITEMS;
}

//ڑ̃`FbN
HRESULT Cyv122nv12::CheckTransform(
    const CMediaType *mtIn, const CMediaType *mtOut)
{

	BITMAPINFOHEADER *pbmiIn, *pbmiOut;
	RECT *prcSrc, *prcTarget;

	if (mtIn->formattype == FORMAT_VideoInfo && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER))
	{
		pbmiIn = &((VIDEOINFOHEADER *)(mtIn->pbFormat))->bmiHeader;
		prcSrc = &((VIDEOINFOHEADER *)(mtIn->pbFormat))->rcSource;
	}
	else if (mtIn->formattype == FORMAT_VideoInfo2 && mtIn->cbFormat >= sizeof(VIDEOINFOHEADER2))
	{
		pbmiIn = &((VIDEOINFOHEADER2 *)(mtIn->pbFormat))->bmiHeader;
		prcSrc = &((VIDEOINFOHEADER2 *)(mtIn->pbFormat))->rcSource;
	}else{
		return E_UNEXPECTED;
	}

	if (mtOut->formattype == FORMAT_VideoInfo && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmiOut   = &((VIDEOINFOHEADER *)(mtOut->Format()))->bmiHeader;
		prcTarget = &((VIDEOINFOHEADER *)(mtOut->Format()))->rcTarget;
	}
	else if (mtOut->formattype == FORMAT_VideoInfo2 && mtOut->cbFormat >= sizeof(VIDEOINFOHEADER2)){
		pbmiOut   = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->bmiHeader;
		prcTarget = &((VIDEOINFOHEADER2 *)(mtOut->Format()))->rcTarget;
	}else{
		return E_UNEXPECTED;
	}
	//biWidth̓XgCh̒l
	swOut = pbmiOut->biWidth;
	hOut = abs(pbmiOut->biHeight);
	swIn = pbmiIn->biWidth;
	hIn = abs(pbmiIn->biHeight);

	//قȂ邱Ƃ͂肦ȂEE
	if (hOut != hIn) {
		return VFW_E_INVALIDMEDIATYPE;
	}

	// ]`Ɠ]`rB
	// ܂Ӗ킩ĂȂB
    RECT rcImg;
	SetRect(&rcImg, 0, 0, swIn, hIn);
	if (IsRectEmpty(prcSrc) || EqualRect(prcSrc, &rcImg)) {
		// XgChlȂĂ悢ꍇ
		wIn = swIn;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcSrc->right;
		// ̓f[^̃XgChl
		if(!EqualRect(prcSrc, &rcImg2) || rcImg2.right>swIn) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		wIn = rcImg2.right;
	}
	SetRect(&rcImg, 0, 0, swOut, hOut);
	if (IsRectEmpty(prcTarget) || EqualRect(prcTarget, &rcImg)) {
		wOut = swOut;
	} else {
		RECT rcImg2 = rcImg;
		rcImg2.right = prcTarget->right;
		// o̓f[^̃XgChl
		if(!EqualRect(prcTarget, &rcImg2) || rcImg2.right>swOut) {
			return VFW_E_INVALIDMEDIATYPE;
		}
		wOut = rcImg2.right;
	}

	// wOut,wIn͌󗘗pĂȂǁAꉞ`FbN
	if (wOut != wIn) {
		return VFW_E_INVALIDMEDIATYPE;
	}
	
    // ׂĖȂB
    return S_OK;
}

HRESULT Cyv122nv12::DecideBufferSize(
    IMemAllocator *pAlloc, ALLOCATOR_PROPERTIES *pProp)
{
    AM_MEDIA_TYPE mt;
    HRESULT hr = m_pOutput->ConnectionMediaType(&mt);
    if (FAILED(hr))
    {
        return hr;
    }

    //BITMAPINFOHEADERTCY𓾂
    BITMAPINFOHEADER *pbmi;
	if (mt.formattype == FORMAT_VideoInfo && mt.cbFormat >= sizeof(VIDEOINFOHEADER)){
		pbmi = &((VIDEOINFOHEADER *)(mt.pbFormat))->bmiHeader;
	} else if (mt.formattype == FORMAT_VideoInfo2 && mt.cbFormat >= sizeof(VIDEOINFOHEADER2)) {
		pbmi = &((VIDEOINFOHEADER2 *)(mt.pbFormat))->bmiHeader;
	} else {
		//ɂ͗Ȃ
		return E_UNEXPECTED;
	}
	//őH
    pProp->cbBuffer = DIBSIZE(*pbmi); 
    if (pProp->cbAlign == 0)
    {
        pProp->cbAlign = 1;
    }
    if (pProp->cBuffers == 0)
    {
        pProp->cBuffers = 1;
    }
    // tH[}bg ubNB
    FreeMediaType(mt);

    // AP[^ vpeBݒ肷B
    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProp, &Actual);
    if (FAILED(hr)) 
    {
        return hr;
    }
    // ꍇAۂ̌ʂmFB
    if (pProp->cbBuffer > Actual.cbBuffer) 
    {
        return E_FAIL;
    }
    return S_OK;
}

//ۂ̕ϊ
HRESULT Cyv122nv12::Transform(IMediaSample *pSource, IMediaSample *pDest)
{
	// _EXg[̃tH[}bgύXB
    CMediaType *pMT = NULL;
    HRESULT hr = pDest->GetMediaType((AM_MEDIA_TYPE**)&pMT);
    if (hr == S_OK)
    {
        hr = m_pOutput->CheckMediaType(pMT);
        if(FAILED(hr))
        {
            DeleteMediaType(pMT);
            return E_FAIL;
        }
        // V^CvɂĎg̏o̓sɒʒmB
        m_pOutput->SetMediaType(pMT);

		//XgChύX㗬ɒʒmꍇ
		if (static_cast<Cyv122nv12InputPin*>(m_pInput)->UsingCustomAllocater()) {
			BITMAPINFOHEADER *pbmi;
			
			pMT->subtype = MEDIASUBTYPE_YV12;
			//BITMAPINFOHEADERł̃^Cvw
			if (pMT->formattype == FORMAT_VideoInfo && pMT->cbFormat >= sizeof(VIDEOINFOHEADER))
			{
				pbmi = &((VIDEOINFOHEADER *)(pMT->Format()))->bmiHeader;
			}
			else if (pMT->formattype == FORMAT_VideoInfo2 && pMT->cbFormat >= sizeof(VIDEOINFOHEADER2))
			{
				pbmi = &((VIDEOINFOHEADER2 *)(pMT->Format()))->bmiHeader;
			}
			else
			{
				return E_UNEXPECTED;
			}
			pbmi->biCompression = FCC('YV12');

			if(pSource->GetSize() >= DIBSIZE(*pbmi)){ //TCY邩H
				HRESULT hr = m_pInput->GetConnected()->QueryAccept(pMT);
				if(S_OK == hr){
					static_cast<Cyv122nv12InputPin*>(m_pInput)->ChangeMediaType(pMT);
				}
			}
		} //XgChύX㗬ɒʒmꍇ ܂
        DeleteMediaType(pMT);
    }

	// AbvXg[ւ̃tH[}bgύXLɂȂۂB
    hr = pSource->GetMediaType((AM_MEDIA_TYPE**)&pMT);
    if (hr == S_OK)
    {
         // V^CvɂĎg̏o̓sɒʒmB
        m_pInput->SetMediaType(pMT);
        DeleteMediaType(pMT);
    }

    // ɂȂobt@ւ̃|C^擾B
    BYTE *pBufferIn, *pBufferOut;
    hr = pSource->GetPointer(&pBufferIn);
    if (FAILED(hr))
    {
        return hr;
    }
    hr = pDest->GetPointer(&pBufferOut);
    if (FAILED(hr))
    {
        return hr;
    }

    // f[^B
	//CopyMemory(pBufferOut, pBufferIn, pSource->GetSize());
	if(mmx){
		if(swIn == swOut){
			mmx_yv12_2_nv12(pBufferOut, pBufferIn, swIn, hIn);
		}else{
			mmx_yv12_2_nv12a(pBufferOut, pBufferIn, swIn, hIn, swOut, swIn>swOut ? swOut:swIn);
		}
	}else{
		if(swIn == swOut){
			yv12_2_nv12(pBufferOut, pBufferIn, swIn, hIn);
		}else{
			yv12_2_nv12a(pBufferOut, pBufferIn, swIn, hIn, swOut, swIn>swOut ? swOut:swIn);
		}
	}


	//ۂ̃f[^ʒm
	pDest->SetActualDataLength((swOut + ((swOut + 1) >> 1)) * hOut);
	//L[t[łB
    pDest->SetSyncPoint(TRUE);

    return S_OK;
}

//tB^̓o^
STDAPI DllRegisterServer(void)
{
    HRESULT hr = AMovieDllRegisterServer2(TRUE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->RegisterFilter(
            CLSID_YV122NV12,           // tB^ CLSIDB
            g_wszName,                       // tB^B
            NULL,                            // foCX jJB
            &CLSID_LegacyAmFilterCategory,   // Dsf
            NULL,                       // CX^X f[^B
            &rf2FilterReg                    // tB^B
            );
        pFM2->Release();
    }
    return hr;
}

//tB^̓o^
STDAPI DllUnregisterServer()
{
    HRESULT hr = AMovieDllRegisterServer2(FALSE);
    if (FAILED(hr))
    {
        return hr;
    }
    IFilterMapper2 *pFM2 = NULL;
    hr = CoCreateInstance(CLSID_FilterMapper2, NULL, CLSCTX_INPROC_SERVER,
            IID_IFilterMapper2, (void **)&pFM2);
    if (SUCCEEDED(hr))
    {
        hr = pFM2->UnregisterFilter(&CLSID_LegacyAmFilterCategory, 
            NULL, CLSID_YV122NV12);
        pFM2->Release();
    }
    return hr;
}


CUnknown *Cyv122nv12::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
    Cyv122nv12 *pFilter = new Cyv122nv12(NAME("YV12 to NV12 converter"), pUnk);
    if (pFilter== NULL) 
    {
        *pHr = E_OUTOFMEMORY;
    }
    return pFilter;
}

/*
 * YV12 -> NV12
 * XgChlver
 *
 * BYTE *pBufferOut : o̓obt@ւ̃|C^
 * BYTE *pBufferIn  : ̓obt@ւ̃|C^
 * LONG swIn        : ̓C[W̕(+XgCh)
 * LONG Height      : o̓C[W̍
 * LONG swOut       : o̓C[W̕(+XgCh)
 * LONG Width       : ۂɃRs[镝
 */
void yv12_2_nv12a(BYTE *pBufferOut, BYTE *pBufferIn, LONG swIn, LONG Height, LONG swOut, LONG Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = Width >> 1;
	int hHeight = Height >> 1;
	int offsYV = (swIn * Height)>> 2;
	BYTE *tmp_pBufferIn;
	BYTE *tmp_pBufferOut;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		CopyMemory(pBufferOut, pBufferIn, Width);
		pBufferOut += swOut;
		pBufferIn  += swIn;
	}
	
	tmp_pBufferOut = pBufferOut;
	tmp_pBufferIn  = pBufferIn;

	//UYC^[[uȂRs[
	for(i=0; i<hHeight; ++i) {
		for(j=0; j<hWidth; ++j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
		tmp_pBufferOut += swOut;
		tmp_pBufferIn  += swIn>>1;
		pBufferOut = tmp_pBufferOut;
		pBufferIn  = tmp_pBufferIn;
	}
	
}

/*
 * YV12 -> NV12
 * XgChlver
 *@MMXp
 */
void mmx_yv12_2_nv12a(BYTE *pBufferOut, BYTE *pBufferIn, LONG swIn, LONG Height, LONG swOut, LONG Width)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = Width >> 1;
	int hHeight = Height >> 1;
	int offsYV = (swIn * Height)>> 2;
	BYTE *tmp_pBufferIn;
	BYTE *tmp_pBufferOut;

	//ỸRs[
	for(i=0; i<Height; ++i) {
		CopyMemory(pBufferOut, pBufferIn, Width);
		pBufferOut += swOut;
		pBufferIn  += swIn;
	}
	
	tmp_pBufferOut = pBufferOut;
	tmp_pBufferIn  = pBufferIn;

	//UYC^[[uȂRs[
	for(i=0; i<hHeight; ++i) {
		for(j=hWidth; j>7; j-=8) {
			__m64 u0,v0,v1;
			u0 = *(__m64 *)(pBufferIn + offsYV);
			v0 = *(__m64 *)pBufferIn;
			v1 = v0;
			v0 = _mm_unpackhi_pi8(u0, v0);
			v1 = _mm_unpacklo_pi8(u0, v1);
			*(__m64 *)pBufferOut = v1;
			pBufferOut += 8;
			*(__m64 *)pBufferOut = v0;
			pBufferOut += 8;
			pBufferIn += 8;
		}
		for( ; j>0; --j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
		tmp_pBufferOut += swOut;
		tmp_pBufferIn  += swIn>>1;
		pBufferOut = tmp_pBufferOut;
		pBufferIn  = tmp_pBufferIn;
	}
	_mm_empty();
}


/*
 * YV12 -> NV12
 * XgChvꍇ
 */
void yv12_2_nv12(BYTE *pBufferOut, BYTE *pBufferIn, LONG imgWidth, LONG imgHeight)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = imgWidth >> 1;
	int hHeight = imgHeight >> 1;
	int offsY = imgWidth * imgHeight;
	int offsYV = offsY >> 2;

	//ỸRs[
	CopyMemory(pBufferOut, pBufferIn, offsY);
	
	pBufferOut += offsY;
	pBufferIn += offsY;

	for(i=0; i<hHeight; ++i) {
		for(j=0; j<hWidth; ++j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
	}
	
}

/*
 * YV12 -> NV12
 * XgChvꍇ MMXp
 */
void mmx_yv12_2_nv12(BYTE *pBufferOut, BYTE *pBufferIn, LONG imgWidth, LONG imgHeight)
{
	//rbg[x2 ̗ݏł͂ȂYUV tH[}bg̏ꍇA̓oCgPʂŎw肷B 
	int i,j;
	int hWidth = imgWidth >> 1;
	int hHeight = imgHeight >> 1;
	int offsY = imgWidth * imgHeight;
	int offsYV = offsY >> 2;

	//ỸRs[
	CopyMemory(pBufferOut, pBufferIn, offsY);
	
	pBufferOut += offsY;
	pBufferIn += offsY;

	for(i=0; i<hHeight; ++i) {
		for(j=hWidth; j>7; j-=8) {
			__m64 u0,v0,v1;
			u0 = *(__m64 *)(pBufferIn + offsYV);
			v0 = *(__m64 *)pBufferIn;
			v1 = v0;
			v0 = _mm_unpackhi_pi8(u0, v0);
			v1 = _mm_unpacklo_pi8(u0, v1);
			*(__m64 *)pBufferOut = v1;
			pBufferOut += 8;
			*(__m64 *)pBufferOut = v0;
			pBufferOut += 8;
			pBufferIn += 8;
		}
		for( ; j>0; --j) {
			*pBufferOut = *(pBufferIn + offsYV);
			++pBufferOut;
			*pBufferOut = *pBufferIn;
			++pBufferOut;
			++pBufferIn;
		}
	}
	_mm_empty();	
}
